#!/usr/local/bin/perl5
# kwnmz.pl - by furukawa@tcp-ip.or.jp
# NMZ.f  keyword ղä
{
    my($tmp) = $0;
    $tmp = "./$tmp" if $tmp !~ /[\/\\]/;
    while ($tmp =~ /^(.*[\/\\])/){
        unshift(@INC, $1);
        last if !-l $tmp;
        $tmp = $1 . $tmp if ($tmp = readlink($tmp)) !~ /^\//;
    }
}

require 'nmztxt.pl';

# ƥݥե
$W = 'WORD.tmp';
$FI = 'FLIST_I.tmp';
$FO = 'FLIST_O.tmp';

$| = 1;
&nmztxt::init('NMZ');
# ǡ١ -> ƥȤѴ
&nmztxt::flist2txt($FI);
&nmztxt::word2txt($W);


# Ĥä Keywords ο
$KW = 10;

# ҥåȤʸ¿ϡKeywords ȤŬ
# ȤꤢʸȾʬ
$lim = int($nmztxt::FILE / 2);


# ƥȤβù
$/ = '';
open(W, $W);
while (defined($welem = <W>)){
    #  3 ʸʾ塢 2 ʸʾθ줬о
    if ($welem =~ /^(\xa5.){3}/ || $welem =~ /^([\xb0-\xf4].){2}/){
        ($word, @hits) = split(/\n/, $welem);
        $hitnum = scalar(@hits);

        # ҥåȿ¿ϡʤꤳߤΩʤ
        next if $hitnum > $lim;

        # ҥåȿ 1 θϡθޤ¾ʸ¸ߤʤȤ
        # ̣ΤǡϢʸФΤΩʤ
        next if $hitnum <= 1;

        for $helem (@hits){
            ($fileno, $score) = split(/\s+/, $helem);
            $tfidf{$fileno}{$word} = $score / log($hitnum)
        }
    }
}

open(FI, $FI);
open(FO, ">$FO");
while (defined($felem = <FI>)){
    ($fileno, $r, $dt, $st, $summary, $dd) = split(/\n/, $felem, 6);
    $summary =~ s/\<\!\-\- KW \-\-\>.*//;
    if ($t = $tfidf{$fileno}){
        $summary .= '<!-- KW --><BR><STRONG>Keywords</STRONG>:<EM>';

        # tf idf ˡɥ˥
        @wlist = sort {($t->{$b} <=> $t->{$a}) || ($a cmp $b)} keys %$t;

        $#wlist = $KW - 1 if $KW < @wlist;

        for $word (@wlist){
            $word =~ s/([\x80-\xff]+)/\e\$B$1\e\(B/g;
            $word =~ tr/\x80-\xff/\x00-\x7f/;
            $summary .= " $word";
        }
        $summary .= '</EM>';
    }
    $felem = "$fileno\n$r\n$dt\n$st\n$summary\n$dd";
    print FO "$felem\n\n";
}
close(FI);
close(FO);

# ǡ١˽᤹
&nmztxt::txt2flist($FO);
&nmztxt::end;

unlink($W);
unlink($FI);
unlink($FO);

# ޤ
